//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "mainform.h"
#include <boost/spirit/core.hpp>
#include <stack>

using namespace boost;
using namespace boost::spirit;
using namespace std;

/**
 * @brief ZsNX
 */
struct add_parser : public grammar<add_parser > {
    stack<double>    _val;    //!>vZpX^bN

    /**
     * @brief X^bN̒gZ(Z}eBbNANV)
     */
	void add ( const char*, const char* last)
    {

        double r = _val.top();
        _val.pop();

        double l = _val.top();
        _val.pop();

        _val.push( l + r );
    }

    /**
     * @brief lX^bNɐς(Z}eBbNANV)
     * @param v l
     */
    void push(double v)
    {
        _val.push(v);
    }

	template<typename S> struct definition {

		rule<S> expr;

		definition(const add_parser& self)
		{
			// \`
			expr = ( real_p[&self.push] >> '+' >> real_p[&self.push] )[&self.add];
		}

		const rule<S>& start() const { return expr; }
	};

};

/**
 * @brief Zs
 * @param expr ͂
 * @param ret vZ
 * @return ͐Ȃtrue
 */
bool    Parse ( const char* expr, double &ret ){

    add_parser calc;

    // ͂ꂽcalcŉ
    parse_info<> r = parse(expr, calc, space_p);

    if(r.hit){    // ͂ꂽ̉͐mF
        ret =  calc._val.top();
    }

    return r.hit;
}//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	add_parser	add;

	double	ret;

	if ( Parse(AnsiString(Edit1->Text).c_str(),ret)  ) {
		Edit2->Text = ret;
	} else {
		Edit2->Text = "͎s";
	}
}
//---------------------------------------------------------------------------
